package com.qmth.distributed.print.api.mark;

import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import com.qmth.teachcloud.mark.bean.UpdateTimeVo;
import com.qmth.teachcloud.mark.bean.student.AbsentManualUpdateVo;
import com.qmth.teachcloud.mark.bean.student.StudentQuery;
import com.qmth.teachcloud.mark.service.MarkStudentService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;

/**
 * <p>
 * 考生 前端控制器
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
@Api(tags = "扫描-考生")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + SystemConstant.PREFIX_URL_SCAN + "/student")
public class ScanStudentController {
    @Autowired
    private MarkStudentService markStudentService;

    @ApiOperation(value = "考生查询")
    @RequestMapping(value = "find", method = RequestMethod.POST)
    public Result student(@Validated StudentQuery query) {
        return ResultUtil.ok(markStudentService.findOne(query));
    }

    @ApiOperation(value = "更新缺考状态")
    @PostMapping("absent/update")
    public AbsentManualUpdateVo absentManualUpdate(@RequestParam Long examId, @RequestParam String coursePaperId,
                                                   @RequestParam String studentCode) {
        return markStudentService.absentManualUpdate(examId, coursePaperId, studentCode);
    }

    @ApiOperation(value = "任务确认")
    @PostMapping("confirm")
    public UpdateTimeVo confirm(@RequestParam Long examId, @RequestParam String coursePaperId,
                                @RequestParam String studentCode, @RequestParam(required = false) Boolean omrAbsent) {
        return markStudentService.confirm(examId, coursePaperId, studentCode, omrAbsent);
    }

    /**
     * 导出评卷员工作量
     */
    @ApiOperation(value = "未扫描-导出")
    @RequestMapping(value = "/unexist/export", method = RequestMethod.POST)
    public void exportUnexist(@ApiParam(value = "考试ID", required = true) @RequestParam Long examId,
                              HttpServletResponse response) {
        markStudentService.exportUnexist(examId, response);
    }
}
